C     Last change:  JG   30 Oct 97    4:41 pm
c
      subroutine mbal(tmoa,tmwa,tmon,tmog,tmgg)
c
c program to perform 2-D gauss quadrature 
c      uses 4 points (2-D)
cintrgrates soln. over domain to find area under curve
c this is the amount of injected fluid in the domain
c
        include 'include.f'
c
        dimension na(4),rog(4)
        dimension roa(4),sw(4),ppor(4),st(4)
c
         tmwa = 0.d0
         tmoa = 0.d0
         tmon = 0.d0
         tmgg = 0.d0
         tmog = 0.d0
c
c----------------------------------------------------------------
c everything is set up for the integration
c loop through the elements, and for each element integrate
c the nodal soln.  this gives the concentration in a given element   
c its a normal mass balance calaulation- find the area under the curve
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        kelem = 1
        do 30 n = 1, nex
        do 40 m = 1, ney
c
c calc the solution at the gauss points
          do 170 kh = 1, 4
	      roa(kh)  = 0.d0
	      rog(kh)  = 0.d0
	       sw(kh)  = 0.d0
	       st(kh)  = 0.d0
	      ppor(kh) = 0.d0
  170     continue
c
c what are the nodes associated with this element
	      na(1) = nel(kelem,1)
	      na(2) = nel(kelem,2)
	      na(3) = nel(kelem,3)
	      na(4) = nel(kelem,4)
c
c loop through 
c       nodes
        do 50 j = 1, 4
c       collocation points
          do 180 ir = 1, 4
c
	   ppor(ir) = ppor(ir) + por(na(j))*b1(ir,j)
c
	roa(ir)=  roa(ir) +roa11(na(j),1)*b3(ir,j,1)
     &                    +roa11(na(j),2)*b3(ir,j,2)*dx(n)/2.d0
     &                    +roa11(na(j),3)*b3(ir,j,3)*dy(m)/2.d0
     &                    +roa11(na(j),4)*b3(ir,j,4)*dx(n)*dy(m)/4.d0
c
	rog(ir)=  rog(ir) +rog11(na(j),1)*b3(ir,j,1)
     &                    +rog11(na(j),2)*b3(ir,j,2)*dx(n)/2.d0
     &                    +rog11(na(j),3)*b3(ir,j,3)*dy(m)/2.d0
     &                    +rog11(na(j),4)*b3(ir,j,4)*dx(n)*dy(m)/4.d0
c
	  sw(ir)=  sw(ir) + sw11(na(j),1)*b3(ir,j,1)
     &                    + sw11(na(j),2)*b3(ir,j,2)*dx(n)/2.d0
     &                    + sw11(na(j),3)*b3(ir,j,3)*dy(m)/2.d0
     &                    + sw11(na(j),4)*b3(ir,j,4)*dx(n)*dy(m)/4.d0
c
	  st(ir)=  st(ir) + st11(na(j),1)*b3(ir,j,1)
     &                    + st11(na(j),2)*b3(ir,j,2)*dx(n)/2.d0
     &                    + st11(na(j),3)*b3(ir,j,3)*dy(m)/2.d0
     &                    + st11(na(j),4)*b3(ir,j,4)*dx(n)*dy(m)/4.d0
c
  180       continue
   50    continue
c
c
c mass integrated over the 4 Gauss points in the element
c the summed integration
c
	do 92 k = 1, 4
c
c fluid properties
                  call water_prop (roa(k),rwa,dww,visw)
                  call   gas_prop (rog(k),rgg,dgg,visg)
c
        tmwa = tmwa + rwa*   sw(k)*ppor(k)*dx(n)*dy(m)/4.d0
        tmoa = tmoa + sw(k)*ppor(k)*roa(k)*dx(n)*dy(m)/4.d0
c
        tmon = tmon + rn_r*(st(k)-sw(k))*ppor(k)*dx(n)*dy(m)/4.d0
c
        tmgg = tmgg + rgg*   (1.d0 - st(k))*ppor(k)*dx(n)*dy(m)/4.d0
        tmog = tmog + rog(k)*(1.d0 - st(k))*ppor(k)*dx(n)*dy(m)/4.d0
c
   92      continue
c-------------------------------------------------------------------
c
      kelem = kelem + 1
c
   40   continue
   30   continue
c
c we have looped through all the elements and have a sum of sat.
c in each element
c
        return
	end
c
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
c
      subroutine pore_vol (pv)
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
c program to perform 2-D gauss quadrature 
c      uses 4 points (2-D)
c intrgrates soln. over domain to find area under curve
c this is the pore volume in the domain
c
        include 'include.f'
c
	dimension na(4),ppor(4)
c
	pv =  0.d0   
c
c----------------------------------------------------------------
c everything is set up for the integration
c loop through the elements, and for each element integrate
c the nodal soln.  this gives the concentration in a given element   
c its a normal mass balance calaulation- find the area under the curve
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            kelem = 1
        do 30 n = 1, nex
          do 40 m = 1, ney
c
c calc the solution at the gauss points
	   do 170 kh=1,4
	      ppor(kh)=0.d0
  170     continue
	      na(1)=nel(kelem,1)
	      na(2)=nel(kelem,2)
	      na(3)=nel(kelem,3)
	      na(4)=nel(kelem,4)
c
          do 51 i=1,4
            do 181 ir=1,4
c
	       ppor(ir) = ppor(ir) + por(na(i))*b1(ir,i)
c
  181       continue
   51     continue
c
c pore volume integrated over the element
c the summed integration
c
	        do 92 k = 1, 4
c
                    pv = pv + ppor(k)*dx(n)*dy(m)/4.d0
c
   92           continue
c-------------------------------------------------------------------
              kelem = kelem + 1
   40     continue
   30   continue
c
c
        return
	end
c
c
c====================================================================
c====================================================================
c====================================================================
      subroutine mbalb(flxowa,flxiwa,flxoon,flxion,flxooa,flxioa,
     &                 flxoog,flxiog,flxogg,flxigg)
c====================================================================
c
c CALCULATE THE MASS OVER EACH BOUNDARY LINE
c
c OMIT DISPERSIVE FLUX OVER THE BOUNDARY
c
c Given the normal component of velocity at each boundary node, 
c multiply it by the mass at that node and the length associated 
c  with the node:
c length = the sum of 1/2 the element lengths associated 
c  with the node
c
        include 'include.f'
c
c the mass in and out for the different species for this time step
         flxowa=0.d0
         flxiwa=0.d0
           flxoon=0.d0
           flxion=0.d0
         flxooa=0.d0
         flxioa=0.d0
           flxogg=0.d0
           flxigg=0.d0
         flxoog=0.d0
         flxiog=0.d0
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c x-faces, normal is y
          k = 0
      do 168 j = 1, 2
        do 169 jj = 1, nnx
c
        if ( ib_x(jj,j) .eq. 5 )  then
c
c index for x-numbering
               nod = k + (jj-1)*nny + 1
c
c fluid properties
                  call water_prop (roa11(nod,1),wa,dww,visw)
                  call   gas_prop (rog11(nod,1),gg,dgg,visg)
                   call disp_w (nod, dspx, dspyw, dspxy)
                   call disp_g (nod, dspx, dspyg, dspxy)
                   vny = vty(nod) - vwy(nod) - vgy(nod)
c
c length
                 if(jj.eq.1)then
                     ddx = dx(1)/2.d0
                 else if(jj.eq.nnx)then
                     ddx = dx(nex)/2.d0
                 else
                     ddx = dx(jj)/2.d0 + dx(jj-1)/2.d0
                 endif
c
c mass flux of the 5 constituents
                   flxwa =  dt* wa * vwy(nod) *ddx
                   flxgg =  dt* gg * vgy(nod) *ddx
                   flxon =  dt*rn_r* vny *ddx
c
                   flxoa =  dt*ddx*
     &                    (roa11(nod,1)*vwy(nod) - dspyw*roa11(nod,3))
                   flxog =  dt*ddx*
     &                    (rog11(nod,1)*vgy(nod) - dspyg*rog11(nod,3))
c
c is this mass in or out
               if(j.eq.1)   then
                 if(flxwa.lt.0.d0) then
                   flxowa = flxowa + dabs(flxwa)
                 else
                   flxiwa = flxiwa + dabs(flxwa)
                 endif
                    if(flxgg.lt.0.d0) then
                      flxogg = flxogg + dabs(flxgg)
                    else
                      flxigg = flxigg + dabs(flxgg)
                    endif
                       if(flxoa.lt.0.d0) then
                         flxooa = flxooa + dabs(flxoa)
                       else
                         flxioa = flxioa + dabs(flxoa)
                       endif
                          if(flxon.lt.0.d0) then
                            flxoon = flxoon + dabs(flxon)
                          else
                            flxion = flxion + dabs(flxon)
                          endif
                             if(flxog.lt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               else
                 if(flxwa.gt.0.d0) then
                   flxowa = flxowa + dabs(flxwa)
                 else
                   flxiwa = flxiwa + dabs(flxwa)
                 endif
                    if(flxoa.gt.0.d0) then
                      flxooa = flxooa + dabs(flxoa)
                    else
                      flxioa = flxioa + dabs(flxoa)
                    endif
                       if(flxon.gt.0.d0) then
                         flxoon = flxoon + dabs(flxon)
                       else
                         flxion = flxion + dabs(flxon)
                       endif
                          if(flxgg.gt.0.d0) then
                            flxogg = flxogg + dabs(flxgg)
                          else
                            flxigg = flxigg + dabs(flxgg)
                          endif
                                if(flxog.gt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               endif
c
        else if ( ibog_x(jj,j) .eq. 3 )  then
c
c index for x-numbering
               nod = k + (jj-1)*nny + 1
c
c length
                 if(jj.eq.1)then
                     ddx = dx(1)/2.d0
                 else if(jj.eq.nnx)then
                     ddx = dx(nex)/2.d0
                 else
                     ddx = dx(jj)/2.d0 + dx(jj-1)/2.d0
                 endif
c
c mass flux of the 5 constituents
                   flxog =  -dt*ddx*rog11(nod,1)*diffg/d_layer
c
c is this mass in or out
               if(j.eq.1)   then
                             if(flxog.lt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               else
                             if(flxog.gt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               endif
        endif
c
  169   continue
          k = ney
  168 continue
c
c y-face, normal is x
c
          k = 0
      do 68 j = 1, 2
        do 69 jj = 1, nny
c
        if ( ib_y(jj,j) .eq. 5 )  then
c
c index for y-numbering
               nod = k+jj
c
c phase properties
                  call water_prop (roa11(nod,1),wa,dww,visw)
                  call   gas_prop (rog11(nod,1),gg,dgg,visg)
                   call disp_w (nod, dspxw, dspy, dspxy)
                   call disp_g (nod, dspxg, dspy, dspxy)
                   vnx = vtx(nod) - vwx(nod) - vgx(nod)
c
c length
                 if(jj.eq.1)then
                     ddy = dy(1)/2.d0
                 else if(jj.eq.nny)then
                     ddy = dy(ney)/2.d0
                 else
                     ddy = dy(jj)/2.d0 + dy(jj-1)/2.d0
                 endif
c
c mass flux
                   flxwa =  dt* wa * vwx(nod) *ddy
                   flxgg =  dt* gg * vgx(nod) *ddy
                   flxon =  dt* rn_r * vnx *ddy
c
                   flxoa =  dt*ddy*
     &                    (roa11(nod,1)*vwx(nod) - dspxw*roa11(nod,2))
                   flxog =  dt*ddy*
     &                    (rog11(nod,1)*vgx(nod) - dspxg*rog11(nod,2))
c
c is this mass in or out
               if(j.eq.1)   then
                 if(flxwa.lt.0.d0) then
                   flxowa = flxowa + dabs(flxwa)
                 else
                   flxiwa = flxiwa + dabs(flxwa)
                 endif
                    if(flxgg.lt.0.d0) then
                      flxogg = flxogg + dabs(flxgg)
                    else
                      flxigg = flxigg + dabs(flxgg)
                    endif
                       if(flxoa.lt.0.d0) then
                         flxooa = flxooa + dabs(flxoa)
                       else
                         flxioa = flxioa + dabs(flxoa)
                       endif
                          if(flxon.lt.0.d0) then
                            flxoon = flxoon + dabs(flxon)
                          else
                            flxion = flxion + dabs(flxon)
                          endif
                             if(flxog.lt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               else
                 if(flxwa.gt.0.d0) then
                   flxowa = flxowa + dabs(flxwa)
                 else
                   flxiwa = flxiwa + dabs(flxwa)
                 endif
                    if(flxoa.gt.0.d0) then
                      flxooa = flxooa + dabs(flxoa)
                    else
                      flxioa = flxioa + dabs(flxoa)
                    endif
                       if(flxon.gt.0.d0) then
                         flxoon = flxoon + dabs(flxon)
                       else
                         flxion = flxion + dabs(flxon)
                       endif
                          if(flxgg.gt.0.d0) then
                            flxogg = flxogg + dabs(flxgg)
                          else
                            flxigg = flxigg + dabs(flxgg)
                          endif
                                if(flxog.gt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               endif
c
        else if ( ibog_y(jj,j) .eq. 3 )  then
c
c index for y-numbering
               nod = k+jj
c
c length
                 if(jj.eq.1)then
                     ddy = dy(1)/2.d0
                 else if(jj.eq.nny)then
                     ddy = dy(ney)/2.d0
                 else
                     ddy = dy(jj)/2.d0 + dy(jj-1)/2.d0
                 endif
c
c mass flux
                   flxog =  -dt*ddy*rog11(nod,1)*diffg/d_layer
c
c is this mass in or out
               if(j.eq.1)   then
                             if(flxog.lt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               else
                             if(flxog.gt.0.d0) then
                               flxoog = flxoog + dabs(flxog)
                             else
                               flxiog = flxiog + dabs(flxog)
                             endif
               endif
        endif
c
   69   continue
          k = nn - nny
   68 continue
c
                                          return
                                          end
